<template>
  <v-container fluid>
    <v-row>
      <v-col cols="2">
        <v-select
            :disabled="statusProgress"
            v-model="vendor"
            :items="vendors"
            label="Pilih Vendor"
            @change="doChangeVendor">
        </v-select>
      </v-col>
      <v-col cols="2">
        <v-select
            :disabled="statusProgress"
            v-model="regional"
            :items="regionals"
            item-text="nama"
            item-value="id"
            label="Pilih Regional"
            @change="doChangeRegional"
        />
      </v-col>
      <v-col cols="2">
        <v-select
            :disabled="statusProgress"
            v-model="witel"
            :items="witels"
            item-text="nama"
            item-value="id"
            label="Pilih Witel"
            @change="doChangeWitel"
        />
      </v-col>
      <v-col cols="2">
        <v-select
            :disabled="statusProgress"
            v-model="sto"
            :items="stos"
            item-text="nama"
            item-value="id"
            label="Pilih STO"
            @change="doChangeSto"
        />
      </v-col>
      <v-col cols="4">
        <v-select
            :disabled="statusProgress"
            v-model="config.ip_gpon"
            :items="gpons"
            item-text="nama"
            item-value="id"
            label="Pilih GPON"
            @change="doChangeGpon"
        />
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="1">
        <v-text-field type="number" v-model="config.slot" :disabled="statusProgress" label="Slot"/>
      </v-col>
      <v-col cols="1">
        <v-text-field type="number" v-model="config.port" :disabled="statusProgress" label="Port"/>
      </v-col>
      <v-col cols="3">
        <v-select
            :disabled="statusProgress"
            v-model="config.onu_type"
            :items="onu_types"
            item-text="nama"
            item-value="id"
            label="Pilih Type ONT"
            @change="doChangeOnuType"
        />
      </v-col>
      <v-col cols="3">
        <v-text-field v-model="config.onu_id" :disabled="statusProgress" label="SN ONT"/>
      </v-col>
      <v-col cols="3">
        <v-text-field v-model="config.onu_name" :disabled="statusProgress" label="DESCRIPTION"/>
      </v-col>
    </v-row>
    <v-row>
      <v-radio-group
          :disabled="true"
          v-model="config.open_ont"
          row
          mandatory
      >
        <v-radio label="CLOSE ONT" :value="1"/>
        <v-radio label="OPEN ONT" :value="2"/>
      </v-radio-group>
    </v-row>
    <v-row>
      <v-radio-group
          :disabled="statusProgress"
          v-model="status_ont"
          row
          mandatory
      >
        <v-radio label="CREATE ONT" :value="1"/>
        <v-radio label="MODIFY ONT" :value="2"/>
      </v-radio-group>
    </v-row>
    <v-row>
      <v-radio-group
          :disabled="statusProgress"
          v-model="status_config"
          row
          mandatory
      >
        <v-radio label="CONFIG" :value="1"/>
        <v-radio label="DELETE" :value="2"/>
      </v-radio-group>
    </v-row>
    <v-row>
      <v-checkbox
          :disabled="statusProgress"
          v-model="status_inet"
          label="INTERNET"
          class="shrink mr-2 mt-0"
      />
      <v-checkbox
          :disabled="statusProgress"
          v-model="status_voip"
          label="VOIP"
          class="shrink mr-2 mt-0"
      />
      <v-checkbox
          :disabled="statusProgress"
          v-model="status_iptv"
          label="IPTV"
          class="shrink mr-2 mt-0"
      />
      <v-checkbox
          :disabled="statusProgress"
          v-model="status_other"
          label="OTHER"
          class="shrink mr-2 mt-0"
      />
    </v-row>
    <v-row>
      <v-col cols="2">
        <v-card-actions>
          <v-btn :disabled="statusProgress" @click="doProccess">Proccess</v-btn>
          <v-btn @click="showProgress" :disabled="statusProgress">Check Progress</v-btn>
        </v-card-actions>
      </v-col>
    </v-row>
    <InetForm
        v-if="status_inet"
        :inet="config.inet"
        :vendor="vendor"
        :disabled="statusProgress"
        :onu_type="config.onu_type"
        :open_ont="config.open_ont"
        :status="status_config"
    ></InetForm>
    <VoipForm
        v-if="status_voip"
        :voip="config.voip"
        :vendor="vendor"
        :disabled="statusProgress"
        :onu_type="config.onu_type"
        :open_ont="config.open_ont"
        :status="status_config"
    ></VoipForm>
    <IptvForm
        v-if="status_iptv"
        :iptv="config.iptv"
        :vendor="vendor"
        :disabled="statusProgress"
        :onu_type="config.onu_type"
        :open_ont="config.open_ont"
        :status="status_config"
    ></IptvForm>
    <OtherForm
        v-if="status_other"
        :other="config.other"
        :vendor="vendor"
        :disabled="statusProgress"
        :open_ont="config.open_ont"
        :status="status_config"
    ></OtherForm>
    <v-dialog
        v-model="dialog"
        fullscreen
        hide-overlay
        transition="dialog-bottom-transition"
        scrollable
    >
      <v-card tile>
        <v-card-title>
          <v-toolbar
              flat
              dark
              color="primary"
          >
            <v-btn
                icon
                dark
                @click="dialog = false"
            >
              <v-icon>mdi-close</v-icon>
            </v-btn>
            <v-toolbar-title>Result</v-toolbar-title>
            <v-spacer></v-spacer>
          </v-toolbar>
        </v-card-title>
        <v-card-text>
          <div v-for="result in results" :key="result.id">
            <div v-html="result.command"></div>
            <div v-html="result.result"></div>
          </div>
        </v-card-text>
      </v-card>
    </v-dialog>
    <v-dialog
        v-model="dialogValidation"
        persistent
        transition="dialog-top-transition"
        max-width="290"
    >
      <v-card>
        <v-card-title class="headline">
          MESSAGE ERROR
        </v-card-title>
        <v-card-text v-text="message"></v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn
              color="green darken-1"
              text
              @click="doError"
          >
            Close
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <DlgMsg ref="dlgMsg" />
    <Loading ref="loading" :dlg-loading="statusProgress" />
  </v-container>
</template>

<script>
import DlgMsg from "../components/dialog/DlgMsg";
import Loading from "../components/dialog/Loading";

import InetForm from "../components/InetForm";
import VoipForm from "../components/VoipForm";
import IptvForm from "../components/IptvForm";
import OtherForm from "../components/OtherForm";

import nmsService from "../service/NmsService"
import regionalService from "../service/RegionalService"
import witelService from "../service/WitelService"
import stoService from "../service/StoService"
import gponService from "../service/GponService"
import configService from "../service/ConfigService"

export default {
  name: "ConfigCheck",
  components: {
    InetForm,
    VoipForm,
    IptvForm,
    OtherForm,
    DlgMsg,
    Loading,
  },
  data: () => ({
    config: {
      ip_gpon: null,
      slot: null,
      port: null,
      slot_port: null,
      onu_id: null,
      onu_type: null,
      onu_name: null,
      open_ont: 1,
      status: 0,
      inet: {
        status: 0,
        vport: null,
        data: [
          {
            mode: 2,
            conn_type: 2,
            ip_mode: 3,
            vlan: 1,
            acc: null,
            pwd: null,
            qos: 0,
            lan: [3],
            ssid: [1],
            bw_up: null,
            bw_down: null,
            disabledWan: false,
          }
        ],
      },
      voip: {
        status: 0,
        vlan: 1,
        vport: null,
        data: [
          {
            pots: 1,
            acc: null,
            pwd: null
          }
        ]
      },
      iptv: {
        status: 0,
        lan: [4]
      },
      other: {
        status: 0,
        data: [
          {
            vlan: 1,
            svlan: 1,
            lan: [],
            name: null,
            bw_up: null,
            bw_down: null
          }
        ]
      }
    },
    regionals: [],
    regional: null,
    witels: [],
    witel: null,
    stos: [],
    sto: null,
    gpons: [],
    gpon: null,
    onu_types: [],
    status_ont: 1,
    status_config: 1,
    status_inet: false,
    status_voip: false,
    status_iptv: false,
    status_other: false,
    dialog: false,
    dialogValidation: false,
    message: null,
    vendors: [],
    vendor: null,
    statusProgress: false,
    results: [],
    status_code: 0,
    groups: [],
    groupRegional: [],
    groupWitel: [],
  }),
  methods: {
    showProgress() {
      this.$router.push(`/progress/batch`)
    },
    async doProccess() {
      this.results = []
      if (this.validation()) {
        this.config.slot_port = `${this.config.slot}-${this.config.port}`
        this.statusProgress = true
        if (this.status_ont === 1 && this.status_config === 1) {
          this.config.status = 1
        } else if (this.status_ont === 1 && this.status_config === 2) {
          this.config.status = 2
        } else {
          this.config.status = 0
        }

        if (this.status_inet) {
          if ((this.status_ont === 1 || this.status_ont === 2) && this.status_config === 1) {
            this.config.inet.status = 1
          } else if (this.status_ont === 2 && this.status_config === 2) {
            this.config.inet.status = 2
          } else {
            this.config.inet.status = 0
          }
        } else {
          this.config.inet.status = 0
        }

        if (this.status_voip) {
          if ((this.status_ont === 1 || this.status_ont === 2) && this.status_config === 1) {
            this.config.voip.status = 1
          } else if (this.status_ont === 2 && this.status_config === 2) {
            this.config.voip.status = 2
          } else {
            this.config.voip.status = 0
          }
        } else {
          this.config.voip.status = 0
        }

        if (this.status_iptv) {
          if ((this.status_ont === 1 || this.status_ont === 2) && this.status_config === 1) {
            this.config.iptv.status = 1
          } else if (this.status_ont === 2 && this.status_config ===2) {
            this.config.iptv.status = 2
          } else {
            this.config.iptv.status = 0
          }
        } else {
          this.config.iptv.status = 0
        }

        if (this.status_other) {
          if ((this.status_ont === 1 || this.status_ont === 2) && this.status_config === 1) {
            this.config.other.status = 1
          } else if (this.status_ont === 2 && this.status_config === 2) {
            this.config.other.status = 2
          } else {
            this.config.other.status = 0
          }
        } else {
          this.config.other.status = 0
        }

        await configService.create(this.config).then(res => {
          let { message, data } = res.data
          this.$refs.dlgMsg.doOpenMsg(message, null, data, true)
          this.statusProgress = false
        }).catch((ex) => {
          console.log(ex)
          this.statusProgress = false
          const {status, data} = ex.response
          console.log(status)
          console.log(data)
          this.message = `ERROR PROCESS CONFIG ASYNC: ${data.message}`
          this.dialogValidation = true
        })
      }
    },
    doError() {
      this.dialogValidation = false
      if (this.results.length !== 0) {
        this.dialog = true
      }
    },
    validation() {
      let isValid = true
      let vendor = this.vendor
      let regional = this.regional
      let witel = this.witel
      let sto = this.sto
      let ip_gpon = this.config.ip_gpon
      let slot = this.config.slot
      let port = this.config.port
      let onu_type = this.config.onu_type
      let onu_id = this.config.onu_id

      if (vendor == null) {
        this.message = "VENDOR HARUS DIPILIH!!!"
        isValid = false
        this.dialogValidation = true
      } else if (regional == null) {
        this.message = "REGIONAL HARUS DIPILIH!!!"
        isValid = false
        this.dialogValidation = true
      } else if (witel == null) {
        this.message = "WITEL HARUS DIPILIH!!!"
        isValid = false
        this.dialogValidation = true
      } else if (sto == null) {
        this.message = "STO HARUS DIPILIH!!!"
        isValid = false
        this.dialogValidation = true
      } else if (ip_gpon == null) {
        this.message = "IP GPON HARUS DIPILIH!!!"
        isValid = false
        this.dialogValidation = true
      } else if (slot == null || slot === '') {
        this.message = "SLOT HARUS DIISI!!!"
        isValid = false
        this.dialogValidation = true
      } else if (port == null || port === '') {
        this.message = "PORT HARUS DIISI!!!"
        isValid = false
        this.dialogValidation = true
      } else if (onu_type == null) {
        this.message = "ONU TYPE HARUS DIPILIH!!!"
        isValid = false
        this.dialogValidation = true
      } else if (onu_id == null || onu_id === '') {
        this.message = "ONU SN HARUS DIISI!!!"
        isValid = false
        this.dialogValidation = true
      } //else if (this.status_ont === 1 && this.status_config === 1) {
      //   isValid = this.childValidation()
      // } else if (this.status_ont === 2 && this.status_config === 1) {
      //   isValid = this.childValidation()
      // } else if (this.status_ont === 2 && this.status_config === 2) {
      //   isValid = this.childValidation()
      // }

      return isValid
    },
    childValidation() {
      let isValid = true
      if (this.status_inet) {
        for (let data of this.config.inet.data) {
          if (data.vlan == null || data.vlan === '') {
            this.message = "VLAN INTERNET HARUS DIISI"
            isValid = false
            this.dialogValidation = true
          } else if ((data.qos == null || data.qos === '') && this.vendor === 'FH' && this.config.open_ont === 1) {
            this.message = "QOS INTERNET HARUS DIISI"
            isValid = false
            this.dialogValidation = true
          } else if (!data.lan.length && this.vendor === 'FH' && this.config.open_ont === 1) {
            this.message = "LAN INTERNET HARUS DICEKLIS"
            isValid = false
            this.dialogValidation = true
          } else if (!data.ssid.length && this.vendor === 'FH' && this.config.open_ont === 1) {
            this.message = "SSID INTERNET HARUS DICEKLIS"
            isValid = false
            this.dialogValidation = true
          } else if ((this.config.inet.vport == null || this.config.inet.vport === '') && this.vendor === 'ZTE') {
            this.message = "VPORT INTERNET HARUS DIISI"
            isValid = false
            this.dialogValidation = true
          } else if (data.conn_type === 2 && data.ip_mode === 3) {
            if (this.vendor === 'FH') {
              if (this.config.open_ont === 1) {
                if (data.acc == null || data.acc === '') {
                  this.message = "ACCOUNT INTERNET HARUS DIISI"
                  isValid = false
                  this.dialogValidation = true
                } else if (data.pwd == null || data.pwd === '') {
                  this.message = "PASSWORD INTERNET HARUS DIISI"
                  isValid = false
                  this.dialogValidation = true
                }
              }
            } else {
              if (data.acc == null || data.acc === '') {
                this.message = "ACCOUNT INTERNET HARUS DIISI"
                isValid = false
                this.dialogValidation = true
              } else if (data.pwd == null || data.pwd === '') {
                this.message = "PASSWORD INTERNET HARUS DIISI"
                isValid = false
                this.dialogValidation = true
              }
            }
          } else if (data.bw_up == null || data.bw_up === '') {
            this.message = "UPLOAD INTERNET HARUS DIISI"
            isValid = false
            this.dialogValidation = true
          } else if (data.bw_down == null || data.bw_down === '') {
            this.message = "DOWNLOAD INTERNET HARUS DIISI"
            isValid = false
            this.dialogValidation = true
          }
        }
      }
      if (this.status_voip) {
        if (this.config.voip.vlan == null || this.config.voip.vlan === '') {
          this.message = "VLAN VOIP HARUS DIISI"
          isValid = false
          this.dialogValidation = true
        } else if ((this.config.voip.vport == null || this.config.voip.vport === '') && this.vendor === 'ZTE') {
          this.message = "VPORT VOIP HARUS DIISI"
          isValid = false
          this.dialogValidation = true
        } else if (!this.config.voip.data.length) {
          if (this.vendor === 'FH') {
            if (this.config.open_ont === 1) {
              this.message = "PILIHAN POTS VOIP BELUM DICEKLIS"
              isValid = false
              this.dialogValidation = true
            }
          } else {
            if (this.config.open_ont === 1) {
              this.message = "PILIHAN POTS VOIP BELUM DICEKLIS"
              isValid = false
              this.dialogValidation = true
            }
          }
        } else if (this.config.voip.data.length) {
          let data = this.config.voip.data
          for (let i in data) {
            if (this.vendor === 'FH') {
              if (this.config.open_ont === 1) {
                if (data[i].acc == null || data[i].acc === '') {
                  this.message = `USERNAME POTS ${i} HARUS DIISI`
                  isValid = false
                  this.dialogValidation = true
                } else if (data[i].pwd == null || data[i].pwd === '') {
                  this.message = `PASSWORD POTS ${i} HARUS DIISI`
                  isValid = false
                  this.dialogValidation = true
                }
              }
            } else {
              if (data[i].acc == null || data[i].acc === '') {
                this.message = `USERNAME POTS ${i} HARUS DIISI`
                isValid = false
                this.dialogValidation = true
              } else if (data[i].pwd == null || data[i].pwd === '') {
                this.message = `PASSWORD POTS ${i} HARUS DIISI`
                isValid = false
                this.dialogValidation = true
              }
            }
          }
        }
      }
      if (this.status_iptv) {
        if (this.vendor === 'FH') {
          if (this.config.open_ont === 1) {
            if (!this.config.iptv.lan) {
              this.message = 'LAN IPTV BELUM DICEKLIS'
              isValid = false
              this.dialogValidation = true
            }
          }
        } else {
          if (!this.config.iptv.lan) {
            this.message = 'LAN IPTV BELUM DICEKLIS'
            isValid = false
            this.dialogValidation = true
          }
        }
      }
      if (this.status_other) {
        let data = this.config.other.data
        if (!data.length) {
          if (this.config.open_ont === 1) {
            this.message = "SERVICE OTHER HARUS DITAMBAH TERLEBIH DAHULU"
            isValid = false
            this.dialogValidation = true
          }
        } else if (data.length) {
          for (let i in data) {
            if ((data[i].name == null || data[i].name === '') && this.vendor === 'ZTE') {
              this.message = "SERVICE NAME HARUS DIISI"
              isValid = false
              this.dialogValidation = true
            } else if (data[i].vlan == null || data[i].vlan === '') {
              this.message = "VLAN OTHER HARUS DIISI"
              isValid = false
              this.dialogValidation = true
            } else if (!data[i].lan.length) {
              if (this.vendor === 'FH') {
                if (this.config.open_ont === 1) {
                  this.message = "LAN OTHER HARUS DIISI"
                  isValid = false
                  this.dialogValidation = true
                }
              } else {
                this.message = "LAN OTHER HARUS DIISI"
                isValid = false
                this.dialogValidation = true
              }
            } else if ((data[i].bw_up == null || data[i].bw_up === '') && this.vendor === 'ZTE') {
              this.message = "UPLOAD OTHER HARUS DIISI"
              isValid = false
              this.dialogValidation = true
            } else if ((data[i].bw_down == null || data[i].bw_down === '') && this.vendor === 'ZTE') {
              this.message = "DOWNLOAD OTHER HARUS DIISI"
              isValid = false
              this.dialogValidation = true
            }
          }
        }
      }
      return isValid
    },
    async doChangeVendor() {
      let vendor = this.vendor
      let data = this.config.inet.data
      for (let i in this.config.inet.data) {
        data[i].mode = 2
        data[i].conn_type = 2
        data[i].ip_mode = 3

        if (i > 0) {
          this.config.inet.data.splice(i, data.length)
        }
      }
      this.regionals = []
      this.witels = []
      this.stos = []
      this.gpons = []
      this.regional = null
      this.witel = null
      this.sto = null
      this.gpon = null
      this.config.onu_type = null
      this.statusProgress = true
      await regionalService.getVendorCreate(vendor).then(res => {
        let regionals = res.data.data
        this.regionals = []
        for (let i in regionals) {
          let regional = {
            id: regionals[i].id,
            nama: regionals[i].nama
          }
          this.regionals.push(regional)
          this.regionals.sort(regionalService.sortOrder("nama"))
        }
      }).catch(ex => {
        this.$refs.dlgMsg.doOpenMsg(ex)
        console.log(ex)
      })
      this.getOntType(vendor)
      this.statusProgress = false
    },
    async doChangeRegional() {
      let regionalId = this.regional
      let vendor = this.vendor
      this.witels = []
      this.stos = []
      this.gpons = []
      this.witel = null
      this.sto = null
      this.gpon = null
      this.statusProgress = true
      await witelService.getRegionalAndVendor(regionalId, vendor).then(res => {
        let witels = res.data.data
        for (let i in witels) {
          let wtl = {
            id: witels[i].id,
            nama: witels[i].nama
          }
          this.witels.push(wtl)
          this.witels.sort(witelService.sortOrder("nama"))
        }
      }).catch(ex => {
        this.$refs.dlgMsg.doOpenMsg(ex)
        console.log(ex)
      })
      this.statusProgress = false
    },
    async doChangeWitel() {
      let witelId = this.witel
      let vendor = this.vendor
      this.stos = []
      this.gpons = []
      this.sto = null
      this.gpon = null
      this.statusProgress = true
      await stoService.getWitelAndVendor(witelId, vendor).then(res => {
        let stos = res.data.data
        for (var i in stos) {
          let sto = {
            id: stos[i].id,
            nama: stos[i].nama
          }
          this.stos.push(sto)
          this.stos.sort(stoService.sortOrder("nama"));
        }
      }).catch(ex => {
        this.$refs.dlgMsg.doOpenMsg(ex)
        console.log(ex)
      })
      this.statusProgress = false
    },
    async doChangeSto() {
      let stoId = this.sto
      let vendor = this.vendor
      this.gpons = []
      this.gpon = null
      this.statusProgress = true
      await gponService.getStoAndVendor(stoId, vendor).then(res => {
        let gpons = res.data.data
        for (var i in gpons) {
          let gpon = {
            id: gpons[i].ip_address,
            nama: `${gpons[i].hostname}(${gpons[i].ip_address})`
          }
          this.gpons.push(gpon)
          this.gpons.sort(gponService.sortOrder("nama"))
        }
      }).catch(ex => {
        this.$refs.dlgMsg.doOpenMsg(ex)
        console.log(ex)
      })
      this.statusProgress = false
    },
    async doChangeGpon() {
      this.statusProgress = true
      await gponService.getIpAdd(this.config.ip_gpon).then(res => {
        let {status, data} = res.data
        for (let inet_data of this.config.inet.data) {
          if (status === 'SUCCESS') {
            inet_data.vlan = data.vlan_inet
            this.config.voip.vlan = data.vlan_voice.replace(' ', '').split('-')[0]
          } else {
            inet_data.vlan = 1
            this.config.voip.vlan = 1
          }
        }
      })
      this.statusProgress = false
    },
    doChangeOnuType() {
      let onu_type = this.config.onu_type
      this.config.open_ont = 1
      if (onu_type.startsWith('OPEN_')) {
        this.config.open_ont = 2
      }
      for (let data of this.config.inet.data) {
        if (onu_type === 'HG6145F') {
          data.ssid = [1, 5]
        } else {
          data.ssid = [1]
        }
      }
    },
    async retrieveVendor() {
      this.statusProgress = true
      await nmsService.getVendor().then(res => {
        this.vendors = res.data.data
      })
      this.statusProgress = false
    },
    getOntType(vendor) {
      gponService.getTypeOnt(vendor).then(res => {
        this.onu_types = []
        if (res.data.status === 'SUCCESS')
          this.onu_types = res.data.data
      }).catch(ex => {
        this.$refs.dlgMsg.doOpenMsg(ex)
        console.log(ex)
      })
    },
  },
  async mounted() {
    await this.retrieveVendor()
  }
}
</script>

<style scoped>

</style>